Index: /palm/trunk/SOURCE/diffusion_u.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_u.f90	(revision 2231)
+++ /palm/trunk/SOURCE/diffusion_u.f90	(revision 2232)
@@ -386,37 +494,70 @@
 !--    other (LES) models showed that the values of the momentum flux becomes
 !--    too large in this case.
-!--    The term containing w(k-1,..) (see above equation) is removed here
-!--    because the vertical velocity is assumed to be zero at the surface.
        IF ( use_surface_fluxes )  THEN
-          k = nzb_u_inner(j,i)+1
-!
-!--       Interpolate eddy diffusivities on staggered gridpoints
-          kmzp = 0.25_wp * ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
-
-          tend(k,j,i) = tend(k,j,i)                                            &
-                      & + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)   &
-                      &            + ( w(k,j,i)   - w(k,j,i-1) ) * ddx         &
-                      &            ) * rho_air_zw(k)                           &
-                      &   - ( -usws(j,i) )                                     &
-                      &   ) * ddzw(k) * drho_air(k)
+!
+!--       Default-type surfaces, upward-facing
+          surf_s = surf_def_h(0)%start_index(j,i)
+          surf_e = surf_def_h(0)%end_index(j,i)
+          DO  m = surf_s, surf_e
+
+             k   = surf_def_h(0)%k(m)
+
+             tend(k,j,i) = tend(k,j,i)                                         &
+                        + ( - ( - surf_def_h(0)%usws(m) )                      &
+                          ) * ddzw(k) * drho_air(k)
+          ENDDO
+!
+!--       Default-type surfaces, dowward-facing (except for model-top fluxes)
+          surf_s = surf_def_h(1)%start_index(j,i)
+          surf_e = surf_def_h(1)%end_index(j,i)
+          DO  m = surf_s, surf_e
+
+             k   = surf_def_h(1)%k(m)
+
+             tend(k,j,i) = tend(k,j,i)                                         &
+                        + ( - surf_def_h(1)%usws(m)                            &
+                          ) * ddzw(k) * drho_air(k)
+          ENDDO
+!
+!--       Natural-type surfaces, upward-facing
+          surf_s = surf_lsm_h%start_index(j,i)
+          surf_e = surf_lsm_h%end_index(j,i)
+          DO  m = surf_s, surf_e
+
+             k   = surf_lsm_h%k(m)
+
+             tend(k,j,i) = tend(k,j,i)                                         &
+                        + ( - ( - surf_lsm_h%usws(m) )                         &
+                          ) * ddzw(k) * drho_air(k)
+          ENDDO
+!
+!--       Urban-type surfaces, upward-facing
+          surf_s = surf_usm_h%start_index(j,i)
+          surf_e = surf_usm_h%end_index(j,i)
+          DO  m = surf_s, surf_e
+
+             k   = surf_usm_h%k(m)
+
+             tend(k,j,i) = tend(k,j,i)                                         &
+                       + ( - ( - surf_usm_h%usws(m) )                          &
+                         ) * ddzw(k) * drho_air(k)
+          ENDDO
+
        ENDIF
-
-!
-!--    Vertical diffusion at the first gridpoint below the top boundary,
-!--    if the momentum flux at the top is prescribed by the user
-       IF ( use_top_fluxes  .AND.  constant_top_momentumflux )  THEN
-          k = nzt
-!
-!--       Interpolate eddy diffusivities on staggered gridpoints
-          kmzm = 0.25_wp * ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
-
-          tend(k,j,i) = tend(k,j,i)                                            &
-                      & + ( ( -uswst(j,i) )                                    &
-                      &   - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)   &
-                      &            + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx       &
-                      &            ) * rho_air_zw(k-1)                         &
-                      &   ) * ddzw(k) * drho_air(k)
+!
+!--    Add momentum flux at model top
+       IF ( use_top_fluxes )  THEN
+          surf_s = surf_def_h(2)%start_index(j,i)
+          surf_e = surf_def_h(2)%end_index(j,i)
+          DO  m = surf_s, surf_e
+
+             k   = surf_def_h(2)%k(m)
+
+             tend(k,j,i) = tend(k,j,i)                                         &
+                           + ( - surf_def_h(2)%usws(m) ) * ddzw(k) * drho_air(k)
+          ENDDO
        ENDIF
 
+
     END SUBROUTINE diffusion_u_ij
 
